/*
 * Theory.h
 *
 *  Created on: 2013-04-14
 *      Author: sam
 */

#ifndef THEORY_H_
#define THEORY_H_

#include "mtl/Vec.h"
#include "mtl/Heap.h"
#include "mtl/Alg.h"
#include "utils/Options.h"
#include "core/SolverTypes.h"

namespace Minisat{

class Theory{
public:
    virtual ~Theory(){};
    virtual int getTheoryIndex()=0;
    virtual void setTheoryIndex(int id)=0;
	virtual void backtrackUntil(int level)=0;
	virtual void newDecisionLevel()=0;
	virtual void enqueueTheory(Lit p)=0;
	virtual bool propagateTheory(vec<Lit> & conflict)=0;
	virtual bool solveTheory(vec<Lit> & conflict)=0;
	virtual Lit decideTheory(){
		return lit_Undef;
	}
	//Lazily construct the reason clause explaining this propagation
	virtual void buildReason(Lit p, vec<Lit> & reason)=0;
	//Informs the theory solver about whether this literal (with this polarity!) ever occurs in its parent solver
	virtual void setLiteralOccurs(Lit l, bool occurs){

	}
	virtual void printStats(int detailLevel=0){

	}
	virtual bool check_solved(){
		return true;
	}
	virtual void printSolution(){

	}
};

}

#endif /* THEORY_H_ */
